/** 
 *   DGPS - Configuration parameters.
 *
 *   (c) Copyright 2007 Federico Bareilles <fede@iar.unlp.edu.ar>,
 *   Instituto Argentino de Radio Astronomia (IAR).
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the License, or (at your option) any later version.
 *     
 *   The author does NOT admit liability nor provide warranty for any
 *   of this software. This material is provided "AS-IS" in the hope
 *   that it may be useful for others.
 *
 **/


#define _GNU_SOURCE

#include <stdio.h>
#include <malloc.h>
#include "parse_tools.h"
#include "dgps_conf.h"


struct dgps_conf *make_dgps_conf(void)
{
	struct dgps_conf *gc= NULL;

	gc = (struct dgps_conf *) malloc(sizeof(struct dgps_conf));

	return gc;
}


struct dgps_conf *dgps_get_conf(char *file)
{
	struct dgps_conf *gc= NULL;
	struct configuration *conf = NULL;
        struct configuration *tag = NULL;

	if (read_conf_file(&conf, file) == 0) {
		gc = make_dgps_conf();
		gc->set_rinex_flag = 0;
		if ((tag = find_conf_tag(conf, "device")) != NULL) {
			snprintf(gc->device, _POSIX_PATH_MAX, "%s", tag->data);
		} else {
			sprintf(gc->device,"/dev/stdin");
		}
		if ((tag = find_conf_tag(conf, "data_dir")) != NULL) {
			snprintf(gc->data_dir, _POSIX_PATH_MAX, 
				 "%s", tag->data);
		} else {
			sprintf(gc->data_dir,".");
		}
		if ((tag = find_conf_tag(conf, "rinex_header")) != NULL) {
			snprintf(gc->rinex_header, _POSIX_PATH_MAX, 
				 "%s", tag->data);
			gc->set_rinex_flag = 1;
		} else {
			*(gc->rinex_header) = 0 ;
		}
		if ((tag = find_conf_tag(conf, "log_port")) != NULL) {
			snprintf(gc->log_port, 16, 
				 "%s", tag->data);
		} else {
			sprintf(gc->data_dir,"com1");
		}

	}	
       
	return gc;
}


int dgps_free_conf(struct dgps_conf *dc)
{
	free(dc);

	return 0;
}
